Redmine - Feature #5159

Ability to add Non-Member watchers to the watch list
2010-03-23 18:38 - Jason Trahan

Status: Closed Start date: 2010-03-23
Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: Issues Estimated time: 0.00 hour
Target version: 1.4.0

Resolution: Fixed

Description

We currently have over 4,000 employees in our company. We would like the ability to add a watcher to the list without having to add
them to the actual project. Since there are over 30 projects currently in our system maintaining a watcher list is becoming a
nightmare because the project managers are having to constantly add the employees to the reporter list so that they can be added to

the watch list.

Related issues:

Related to Redmine - Patch #6226: Add multiple watchers at once and add any r...

Related to Redmine - Feature #9942: Allow non-members to watch issues

Related to Redmine - Feature #11724: Prevent users from seeing other users ba...

Related to Redmine - Defect #15123: "Add watcher" leaks all active users

Related to Redmine - Defect #30370: No validation when adding watcher who is ...
Related to Redmine - Patch #16133: Available watchers on new issue form inclu...

Has duplicate Redmine - Feature #6065: Display/add/remove watchers that are n...

Has duplicate Redmine - Feature #3448: Add issue watcher that isn't a maintainer
Has duplicate Redmine - Feature #4889: Ability to CC users not assigned to a ...
Associated revisions

Revision 8592 - 2012-01-09 19:37 - Jean-Philippe Lang

Ability to add non-member users as watchers (#5159).

Revision 9254 - 2012-03-24 13:57 - Jean-Philippe Lang

Ability to add non-member watchers on issue creation (#5159).

Revision 9307 - 2012-04-02 16:33 - Toshi MARUYAMA

generate i18n "label_search_for_watchers" key (#5159)

History

#1 - 2010-03-25 14:56 - Jon Lumpkin

+1

#2 - 2010-03-25 15:18 - Stephen Fuhry

+1

#3 - 2010-05-14 08:50 - Stanislav German-Evtushenko

It would be very nice!

#4 - 2010-05-14 08:51 - Stanislav German-Evtushenko

| do workaround at the moment, but it's quite useless:
1. Add user to project.

2. Add him as watcher.

3. Remove user from project.

#5 - 2010-05-14 17:28 - Arnaud Martel

| did a quick patch to fix this on my server. I'm pretty sure that Jean-Philippe and Eric will have a nicer solution but, in the meantime, this one works
for me...

First, edit the file app/views/watchers/_watchers.rhtml and insert the following text at line 21:
<% if @project.is_public? %>

<br>or email: <%= text_field 'email_watcher', :size => 80 %>

<% end %>

you should have something like:

<p><%= f.select :user_id, (watched.addable_watcher_users.collect {|m| [m.name, m.id]}), :prompt => true %>
<% if @project.is_public? %>

<br>or email: <%= text_field 'email_watcher', :size => 80 %>

<% end %>

<%= submit_tag 1 (:button_add) %>

Next, edit the file app/controllers/watchers_controller.rb and insert the following text at the start of the new function (line 40):

if params[:email_watcher]

wuser = User.find_by_mail (params|[:email_watcher] [:size80]
if wuser
params[:watcher] [:user_id] = wuser.id
else
raise
end

end

you should have something like:

def new
if params[:email_watcher]
wuser = User.find by _mail (params[:email_watcher] [:size80]
if wuser
params|[:watcher] [:user_id] = wuser.id
else
raise
end
end
@watcher = Watcher.new (params]|[:watcher])

Final step: restart your web server and it should work as you like...

#6 - 2010-07-23 21:27 - Enrique Delgado

+1

Aranaud: Okay so if | understand correctly, with your patch you can add a watcher based on the email, as long as that email matches a redmine
user? How about any email address? More like a "CC" field? Maybe Jean-Philippe and Eric can consider this functionality...

#7 - 2010-07-24 01:25 - Arnaud Martel

You're right: with my patch, emails have to match a redmine user. As you have seen, redmine_cc_addresses plugin seems to be a better choice for
you...

#8 - 2010-09-13 20:38 - Eric Seigne
Did you see #6226 ?

#9 - 2012-01-09 19:41 - Jean-Philippe Lang
- File add_watchers.png added

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Target version set to 1.4.0

- Resolution set to Fixed
https://www.redmine.org/issues/6226

Feature added in r8592.

Watchers can now be added via a dialog box. It displays project members by default and you can use the search field to search for other users.
Multiple users can be added at the same time.

Search for user:

jehn

Evgeny Martvnankow
Foo Bar
hampang zheng

Jeramy Joh

ohn adamson

John Andrews

Add Cancel

#10 - 2012-01-09 21:43 - Jason Trahan

Thank you very much. This will be a tremendous help.

#11 - 2012-03-11 15:34 - Jason Trahan

- Status changed from Closed to Reopened

It appears | can only add the watchers after the ticket is created. It would be nice to be able to add them at the time of ticket creation.

#12 - 2012-03-12 23:58 - Terence Mill

+1 to add groups as well

#13 - 2012-03-18 02:40 - Mischa The Evil

Jason Trahan wrote:

It appears | can only add the watchers after the ticket is created. It would be nice to be able to add them at the time of ticket creation.

See related issue #9500#note-3.

#14 - 2012-03-24 13:57 - Jean-Philippe Lang
- Status changed from Reopened to Closed
Jason Trahan wrote:

It appears | can only add the watchers after the ticket is created. It would be nice to be able to add them at the time of ticket creation.

Added in r9254.
#15 - 2012-07-23 19:02 - Fernando Hartmann
| don't understood how this work !

e Added one watcher user to a issue in with no permission on that project.
¢ Posted some update to a issue

Results:
e Users registered to that project received a email notification
e Other watcher user didn't received nothing

¢ User with no perms on the project didn't have access to a issue

How this feature is supposed to work ? Is there some docs about this ?

#16 - 2012-08-28 10:08 - Maxim Kim
https://www.redmine.org/projects/redmine/repository/svn/revisions/8592
https://www.redmine.org/issues/9500
www.redmine.org/issues/9500#note-3
https://www.redmine.org/projects/redmine/repository/svn/revisions/9254

This change caused a major problems at least for us.
We let our customers to add new issues and watchers. And now our customers can see other customer names, which is inacceptable!
Could you please add asap setting to switch off this feature.
My personal opinion is that right solution was to add permission "can be non-member watcher" as someone suggested earlier.
#17 - 2012-08-28 16:14 - Enrique Delgado
Arnaud Martel wrote:
You're right: with my patch, emails have to match a redmine user. As you have seen, redmine_cc_addresses plugin seems to be a better choice
for you...
Just as a follow up: thanks Arnaud, | did end up going the redmine_cc_addresses route. | also like the new feature. Maybe to ease Maxim's
concerns, some permissions need to be established so that some projects allow watchers from non-members, while some projects do not.
Thanks all for all your fine work.

#18 - 2013-08-22 11:14 - Daniel Hochman

We are running BitNami Redmine 2.3.1 and | am not able to see users in the watchers list unless they are a member of the project. The Projects are
"public” so these users have access. We are using the "Watchers Textinput plugin” - is that causing this issue? Before using that plugin, we had a
long list of checkboxes.

#19 - 2013-10-14 10:24 - Toshi MARUYAMA
- Related to Defect #15123: "Add watcher" leaks all active users added

#20 - 2013-12-07 22:37 - Beni Bilme

We are using bitnami redmine stack for redmine 2.3.3, and watchers function is not working unless the watcher is project member.

#21 - 2013-12-08 09:38 - Toshi MARUYAMA

Beni Bilme wrote:

We are using bithami redmine stack for redmine 2.3.3, and watchers function is not working unless the watcher is project member.

You need to search in text box.

#22 - 2013-12-08 09:41 - Daniel Hochman

No, this is a bug. | am having the same issue as Beni and we are no longer on bitnami stack. This issue needs to be re-opened as a bug. You cannot
add watchers who are not members of the project after issue creation.

#23 - 2013-12-08 10:12 - Toshi MARUYAMA

Daniel Hochman wrote:

No, this is a bug. | am having the same issue as Beni and we are no longer on bitnami stack. This issue needs to be re-opened as a bug. You
cannot add watchers who are not members of the project after issue creation.

If it is on only bitnami, please contact bithami.
If it is on clean Redmine, do not re-open this issue, create new issue.

#24 - 2013-12-08 10:17 - Daniel Hochman
OK thanks. Filed #15622

#25 - 2015-10-04 11:03 - Go MAEDA
- Has duplicate Feature #4889: Ability to CC users not assigned to a project, but with project view rights added

#26 - 2019-01-23 01:55 - Go MAEDA
- Related to Defect #30370: No validation when adding watcher who is not in this project added

#27 - 2020-02-06 01:32 - Go MAEDA

- Related to Patch #16133: Available watchers on new issue form include users who cannot even view issues added

Files
https://www.redmine.org/issues/15622
